import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Line2D;


/**
 * Ein Schrank, der manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 * 
 * @author Claus Albowski
 * @version 3  (sept 10)
 */
public class Schrankwand
extends Moebel
{
    int anzahl;
    Schrank[] schrankwand;
    
    /**
     * Erzeuge eine neue Schrankwand mit einer Standardfarbe und Standardgroesse
     * an einer Standardposition. (Standardkonstruktor)
     */
    public Schrankwand(int anzahl) {
        xPosition = 100;
        yPosition = 100;
        farbe = "schwarz";
        orientierung = 0;
        istSichtbar = false;
        breite = 60*anzahl;
        tiefe  = 37;
        this.anzahl = anzahl;
        schrankwand = new Schrank[anzahl];
        for (int i=0; i<anzahl;i++) {
            schrankwand[i]=new Schrank(i*breite/anzahl, 0, farbe, orientierung, breite/anzahl, tiefe);
        }
    }
    
    /**
     * Erzeuge eine neue Schrankwand.
     * Die Breite muss die Breite der gesamten Schrankwand beschreiben.
     */
    public Schrankwand(int xPosition,
                int yPosition,
                String farbe,
                int orientierung,
                int breite,
                int tiefe,
                int anzahl) {
        this.xPosition = xPosition;
        this.yPosition = yPosition;
        this.farbe = farbe;
        this.orientierung = orientierung;
        istSichtbar = false;
        this.breite = breite;
        this.tiefe  = tiefe;
        this.anzahl = anzahl;
        schrankwand = new Schrank[anzahl];
        for (int i=0; i<anzahl;i++) {
            schrankwand[i]=new Schrank(i*breite/anzahl, 0, farbe, orientierung, breite/anzahl, tiefe);
        }
    }
    
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten
     */
    protected Shape gibAktuelleFigur() {
        // einen GeneralPath definieren
        GeneralPath schrankwandShape = new GeneralPath();
        for (int i=0; i<anzahl;i++) {
            schrankwandShape.append(schrankwand[i].gibAktuelleFigur(), false);
        }
        return transformiere(schrankwandShape);
    }
}
